﻿Imports System.Runtime.InteropServices

Public Class NameSpaceTreeView
    Implements INameSpaceTreeControlEvents

#Region "API"
    <DllImport("Shell32.dll", EntryPoint:="SHCreateItemFromParsingName")>
    <PreserveSig> Private Shared Function SHCreateItemFromParsingName(<[In], MarshalAs(UnmanagedType.LPWStr)> pszPath As String,
                                                                      <[In]> pbc As IntPtr,
                                                                      <[In]> ByRef riid As Guid,
                                                                      <Out, MarshalAs(UnmanagedType.Interface)> ByRef pUnk As Object) As Integer
    End Function

    <DllImport("Shell32.dll", EntryPoint:="SHCreateItemInKnownFolder")>
    <PreserveSig> Private Shared Function SHCreateItemInKnownFolder(<[In]> ByRef kfid As Guid,
                                                                    <[In]> dwKFFlags As KNOWN_FOLDER_FLAG,
                                                                    <[In], MarshalAs(UnmanagedType.LPWStr)> pszItem As String,
                                                                    <[In]> ByRef riid As Guid,
                                                                    <Out, MarshalAs(UnmanagedType.Interface)> ByRef pUnk As Object) As Integer
    End Function

    <DllImport("User32.dll", EntryPoint:="FindWindowExW")>
    Private Shared Function FindWindowExW(<[In]> hWndParent As IntPtr,
                                          <[In]> hWndChildAfter As IntPtr,
                                          <[In], MarshalAs(UnmanagedType.LPWStr)> lpszClass As String,
                                          <[In], MarshalAs(UnmanagedType.LPWStr)> lpszWindow As String) As IntPtr
    End Function

    <DllImport("User32.dll", EntryPoint:="MoveWindow")>
    Private Shared Function MoveWindow(<[In]> hWnd As IntPtr,
                                       <[In]> x As Integer,
                                       <[In]> y As Integer,
                                       <[In]> nWidth As Integer,
                                       <[In]> nHeight As Integer,
                                       <[In], MarshalAs(UnmanagedType.Bool)> bRepaint As Boolean) As <MarshalAs(UnmanagedType.Bool)> Boolean
    End Function

    <DllImport("User32.dll", EntryPoint:="SendMessageW")>
    Private Shared Function SendMessage(<[In]> hWnd As IntPtr,
                                        <[In]> wMsg As Integer,
                                        <[In]> wParam As Integer,
                                        <[In]> lParam As Integer) As Integer

    End Function
#End Region

#Region "Enum"

    Public Enum CheckBoxState As Integer
        Hide = 0
        Unchecked = 1
        Checked = 2
        Indeterminate = 3
    End Enum

    Public Enum SIGDN As Integer
        SIGDN_NORMALDISPLAY = &H0
        SIGDN_PARENTRELATIVEPARSING = &H80018001
        SIGDN_DESKTOPABSOLUTEPARSING = &H80028000
        SIGDN_PARENTRELATIVEEDITING = &H80031001
        SIGDN_DESKTOPABSOLUTEEDITING = &H8004C000
        SIGDN_FILESYSPATH = &H80058000
        SIGDN_URL = &H80068000
        SIGDN_PARENTRELATIVEFORADDRESSBAR = &H8007C001
        SIGDN_PARENTRELATIVE = &H80080001
        SIGDN_PARENTRELATIVEFORUI = &H80094001
    End Enum

    Public Enum SFGAOF As Integer
        SFGAO_CANCOPY = &H1
        SFGAO_CANMOVE = &H2
        SFGAO_CANLINK = &H4
        SFGAO_STORAGE = &H8
        SFGAO_CANRENAME = &H10
        SFGAO_CANDELETE = &H20
        SFGAO_HASPROPSHEET = &H40
        SFGAO_DROPTARGET = &H100
        SFGAO_CAPABILITYMASK = &H177
        SFGAO_PLACEHOLDER = &H800
        SFGAO_SYSTEM = &H1000
        SFGAO_ENCRYPTED = &H2000
        SFGAO_ISSLOW = &H4000
        SFGAO_GHOSTED = &H8000
        SFGAO_LINK = &H10000
        SFGAO_SHARE = &H20000
        SFGAO_READONLY = &H40000
        SFGAO_HIDDEN = &H80000
        SFGAO_DISPLAYATTRMASK = &HFC000
        SFGAO_FILESYSANCESTOR = &H10000000
        SFGAO_FOLDER = &H20000000
        SFGAO_FILESYSTEM = &H40000000
        SFGAO_HASSUBFOLDER = &H80000000
        SFGAO_CONTENTSMASK = &H80000000
        SFGAO_VALIDATE = &H1000000
        SFGAO_REMOVABLE = &H2000000
        SFGAO_COMPRESSED = &H4000000
        SFGAO_BROWSABLE = &H8000000
        SFGAO_NONENUMERATED = &H100000
        SFGAO_NEWCONTENT = &H200000
        SFGAO_CANMONIKER = &H400000
        SFGAO_HASSTORAGE = &H400000
        SFGAO_STREAM = &H400000
        SFGAO_STORAGEANCESTOR = &H800000
        SFGAO_STORAGECAPMASK = &H70C50008
        SFGAO_PKEYSFGAOMASK = &H81044000
    End Enum

    Public Enum SICHINTF As Integer
        SICHINT_DISPLAY = &H0
        SICHINT_CANONICAL = &H10000000
        SICHINT_TEST_FILESYSPATH_IF_NOT_EQUAL = &H20000000
        SICHINT_ALLFIELDS = &H80000000
    End Enum

    Public Enum SIATTRIBFLAGS As Integer
        SIATTRIBFLAGS_AND = &H1
        SIATTRIBFLAGS_OR = &H2
        SIATTRIBFLAGS_APPCOMPAT = &H3
        SIATTRIBFLAGS_MASK = &H3
        SIATTRIBFLAGS_ALLITEMS = &H4000
    End Enum

    Public Enum GETPROPERTYSTOREFLAGS As Integer
        GPS_DEFAULT = &H0
        GPS_HANDLERPROPERTIESONLY = &H1
        GPS_READWRITE = &H2
        GPS_TEMPORARY = &H4
        GPS_FASTPROPERTIESONLY = &H8
        GPS_OPENSLOWITEM = &H10
        GPS_DELAYCREATION = &H20
        GPS_BESTEFFORT = &H40
        GPS_NO_OPLOCK = &H80
        GPS_PREFERQUERYPROPERTIES = &H100
        GPS_EXTRINSICPROPERTIES = &H200
        GPS_EXTRINSICPROPERTIESONLY = &H400
        GPS_VOLATILEPROPERTIES = &H800
        GPS_VOLATILEPROPERTIESONLY = &H1000
        GPS_MASK_VALID = &H1FFF
    End Enum

    Public Enum NSTCSTYLE As Integer
        NSTCS_HASEXPANDOS = &H1
        NSTCS_HASLINES = &H2
        NSTCS_SINGLECLICKEXPAND = &H4
        NSTCS_FULLROWSELECT = &H8
        NSTCS_SPRINGEXPAND = &H10
        NSTCS_HORIZONTALSCROLL = &H20
        NSTCS_ROOTHASEXPANDO = &H40
        NSTCS_SHOWSELECTIONALWAYS = &H80
        NSTCS_NOINFOTIP = &H200
        NSTCS_EVENHEIGHT = &H400
        NSTCS_NOREPLACEOPEN = &H800
        NSTCS_DISABLEDRAGDROP = &H1000
        NSTCS_NOORDERSTREAM = &H2000
        NSTCS_RICHTOOLTIP = &H4000
        NSTCS_BORDER = &H8000
        NSTCS_NOEDITLABELS = &H10000
        NSTCS_TABSTOP = &H20000
        NSTCS_FAVORITESMODE = &H80000
        NSTCS_AUTOHSCROLL = &H100000
        NSTCS_FADEINOUTEXPANDOS = &H200000
        NSTCS_EMPTYTEXT = &H400000
        NSTCS_CHECKBOXES = &H800000
        NSTCS_PARTIALCHECKBOXES = &H1000000
        NSTCS_EXCLUSIONCHECKBOXES = &H2000000
        NSTCS_DIMMEDCHECKBOXES = &H4000000
        NSTCS_NOINDENTCHECKS = &H8000000
        NSTCS_ALLOWJUNCTIONS = &H10000000
        NSTCS_SHOWTABSBUTTON = &H20000000
        NSTCS_SHOWDELETEBUTTON = &H40000000
        NSTCS_SHOWREFRESHBUTTON = &H80000000
    End Enum

    Public Enum NSTCSTYLE2 As Integer
        NSTCS2_DEFAULT = &H0
        NSTCS2_INTERRUPTNOTIFICATIONS = &H1
        NSTCS2_SHOWNULLSPACEMENU = &H2
        NSTCS2_DISPLAYPADDING = &H4
        NSTCS2_DISPLAYPINNEDONLY = &H8
        NTSCS2_NOSINGLETONAUTOEXPAND = &H10
        NTSCS2_NEVERINSERTNONENUMERATED = &H20
    End Enum

    Public Enum SHCONTF As Integer
        SHCONTF_CHECKING_FOR_CHILDREN = &H10
        SHCONTF_FOLDERS = &H20
        SHCONTF_NONFOLDERS = &H40
        SHCONTF_INCLUDEHIDDEN = &H80
        SHCONTF_INIT_ON_FIRST_NEXT = &H100
        SHCONTF_NETPRINTERSRCH = &H200
        SHCONTF_SHAREABLE = &H400
        SHCONTF_STORAGE = &H800
        SHCONTF_NAVIGATION_ENUM = &H1000
        SHCONTF_FASTITEMS = &H2000
        SHCONTF_FLATLIST = &H4000
        SHCONTF_ENABLE_ASYNC = &H8000
        SHCONTF_INCLUDESUPERHIDDEN = &H10000
    End Enum

    Public Enum NSTCROOTSTYLE As Integer
        NSTCRS_VISIBLE = &H0
        NSTCRS_HIDDEN = &H1
        NSTCRS_EXPANDED = &H2
    End Enum

    Public Enum NSTCITEMSTATE As Integer
        NSTCIS_NONE = &H0
        NSTCIS_SELECTED = &H1
        NSTCIS_EXPANDED = &H2
        NSTCIS_BOLD = &H4
        NSTCIS_DISABLED = &H8
        NSTCIS_SELECTEDNOEXPAND = &H10
    End Enum

    Public Enum NSTCGNI As Integer
        NSTCGNI_NEXT = 0
        NSTCGNI_NEXTVISIBLE = 1
        NSTCGNI_PREV = 2
        NSTCGNI_PREVVISIBLE = 3
        NSTCGNI_PARENT = 4
        NSTCGNI_CHILD = 5
        NSTCGNI_FIRSTVISIBLE = 6
        NSTCGNI_LASTVISIBLE = 7
    End Enum

    Public Enum NSTCEHITTEST As Integer
        NSTCEHT_NOWHERE = &H1
        NSTCEHT_ONITEMICON = &H2
        NSTCEHT_ONITEMLABEL = &H4
        NSTCEHT_ONITEMINDENT = &H8
        NSTCEHT_ONITEMBUTTON = &H10
        NSTCEHT_ONITEMRIGHT = &H20
        NSTCEHT_ONITEMSTATEICON = &H40
        NSTCEHT_ONITEM = &H46
        NSTCEHT_ONITEMTABBUTTON = &H1000
    End Enum

    Public Enum NSTCECLICKTYPE As Integer
        NSTCECT_LBUTTON = &H1
        NSTCECT_MBUTTON = &H2
        NSTCECT_RBUTTON = &H3
        NSTCECT_BUTTON = &H3
        NSTCECT_DBLCLICK = &H4
    End Enum

    Private Enum KNOWN_FOLDER_FLAG
        KF_FLAG_DEFAULT = &H0
        KF_FLAG_FORCE_APP_DATA_REDIRECTION = &H80000
        KF_FLAG_RETURN_FILTER_REDIRECTION_TARGET = &H40000
        KF_FLAG_FORCE_PACKAGE_REDIRECTION = &H20000
        KF_FLAG_NO_PACKAGE_REDIRECTION = &H10000
        KF_FLAG_FORCE_APPCONTAINER_REDIRECTION = &H20000
        KF_FLAG_NO_APPCONTAINER_REDIRECTION = &H10000
        KF_FLAG_CREATE = &H8000
        KF_FLAG_DONT_VERIFY = &H4000
        KF_FLAG_DONT_UNEXPAND = &H2000
        KF_FLAG_NO_ALIAS = &H1000
        KF_FLAG_INIT = &H800
        KF_FLAG_DEFAULT_PATH = &H400
        KF_FLAG_NOT_PARENT_RELATIVE = &H200
        KF_FLAG_SIMPLE_IDLIST = &H100
        KF_FLAG_ALIAS_ONLY = &H80000000
    End Enum

    Private Enum VARENUM As UShort
        VT_EMPTY = 0
        VT_NULL = 1
        VT_I2 = 2
        VT_I4 = 3
        VT_R4 = 4
        VT_R8 = 5
        VT_CY = 6
        VT_DATE = 7
        VT_BSTR = 8
        VT_DISPATCH = 9
        VT_ERROR = 10
        VT_BOOL = 11
        VT_VARIANT = 12
        VT_UNKNOWN = 13
        VT_DECIMAL = 14
        VT_I1 = 16
        VT_UI1 = 17
        VT_UI2 = 18
        VT_UI4 = 19
        VT_I8 = 20
        VT_UI8 = 21
        VT_INT = 22
        VT_UINT = 23
        VT_VOID = 24
        VT_HRESULT = 25
        VT_PTR = 26
        VT_SAFEARRAY = 27
        VT_CARRAY = 28
        VT_USERDEFINED = 29
        VT_LPSTR = 30
        VT_LPWSTR = 31
        VT_RECORD = 36
        VT_INT_PTR = 37
        VT_UINT_PTR = 38
        VT_FILETIME = 64
        VT_BLOB = 65
        VT_STREAM = 66
        VT_STORAGE = 67
        VT_STREAMED_OBJECT = 68
        VT_STORED_OBJECT = 69
        VT_BLOB_OBJECT = 70
        VT_CF = 71
        VT_CLSID = 72
        VT_VERSIONED_STREAM = 73
        VT_BSTR_BLOB = 4095
        VT_VECTOR = 4096
        VT_ARRAY = 8192
        VT_BYREF = 16384
        VT_RESERVED = 32768
        VT_ILLEGAL = 65535
        VT_ILLEGALMASKED = 4095
        VT_TYPEMASK = 4095
    End Enum
#End Region

#Region "Const"
    Private Const S_OK As Integer = &H0
    Private Const S_FALSE As Integer = &H1
    Private Const E_NOTIMPL As Integer = &H80004001

    Private Const IID_IOleWindow As String = "00000114-0000-0000-c000-000000000046"
    Private Const IID_IShellItem As String = "43826d1e-e718-42ee-bc55-a1e261c37bfe"
    Private Const IID_IShellItem2 As String = "7e9fb0d3-919f-4307-ab2e-9b1860310c93"
    Private Const IID_IShellItemArray As String = "b63ea76d-1f85-456f-a19c-48159efa858b"
    Private Const IID_IEnumShellItems As String = "70629033-e363-4a28-a567-0db78006e6d7"

    Private Const CLSID_NamespaceTreeControl As String = "ae054212-3535-4430-83ed-d501aa6680e6"
    Private Const IID_INameSpaceTreeControl As String = "028212a3-b627-47e9-8856-c14265554e4f"
    Private Const IID_INameSpaceTreeControl2 As String = "7cc7aed8-290e-49bc-8945-c1401cc9306c"
    Private Const IID_INameSpaceTreeControlEvents As String = "93d77985-b3d8-4484-8318-672cdda002ce"

    ' nur einige Const zum testen für SendMessage -> SysTreeView32
    Private Const TV_FIRST As Integer = &H1100
    Private Const TVM_GETINDENT As Integer = TV_FIRST + 6
    Private Const TVM_SETINDENT As Integer = TV_FIRST + 7
    Private Const TVM_SETITEMHEIGHT As Integer = TV_FIRST + 27
    Private Const TVM_GETITEMHEIGHT As Integer = TV_FIRST + 28
    Private Const TVM_SETBKCOLOR As Integer = TV_FIRST + 29
    Private Const TVM_SETTEXTCOLOR As Integer = TV_FIRST + 30
    Private Const TVM_GETBKCOLOR As Integer = TV_FIRST + 31
    Private Const TVM_GETTEXTCOLOR As Integer = TV_FIRST + 32
    Private Const TVM_SETLINECOLOR As Integer = TV_FIRST + 40
    Private Const TVM_GETLINECOLOR As Integer = TV_FIRST + 41
#End Region

#Region "Class"
    Public Sub New()
        m_NameSpaceTreeControl = DirectCast(Activator.CreateInstance(Type.GetTypeFromCLSID(
                                                                     New Guid(CLSID_NamespaceTreeControl))),
                                                                     INameSpaceTreeControl2)
        m_NameSpaceTreeControl?.TreeAdvise(Marshal.GetComInterfaceForObject(Me, GetType(INameSpaceTreeControlEvents)), m_Cookie)
    End Sub
    Protected Overrides Sub Finalize()
        If m_NameSpaceTreeControl IsNot Nothing Then
            If m_Cookie <> 0 Then m_NameSpaceTreeControl.TreeUnadvise(m_Cookie)
            Marshal.ReleaseComObject(m_NameSpaceTreeControl)
            m_NameSpaceTreeControl = Nothing
        End If
        MyBase.Finalize()
    End Sub
#End Region

#Region "Struct"
    Public Structure PROPERTYKEY
        Dim fmtid As Guid
        Dim pid As Integer
    End Structure

    Private Structure CArray
        Dim cElems As UInteger
        Dim pElems As IntPtr
    End Structure

    <StructLayout(LayoutKind.Explicit, Size:=16)> 'gekürzt
    Private Structure PROPVARIANT
        <FieldOffset(0)> Dim vt As VARENUM
        <FieldOffset(2)> Dim wReserved1 As UShort
        <FieldOffset(4)> Dim wReserved2 As UShort
        <FieldOffset(6)> Dim wReserved3 As UShort
        <FieldOffset(8)> Dim bVal As Byte
        <FieldOffset(8)> Dim cVal As SByte
        <FieldOffset(8)> Dim uiVal As UShort
        <FieldOffset(8)> Dim iVal As Short
        <FieldOffset(8)> Dim uintVal As UInteger
        <FieldOffset(8)> Dim intVal As Integer
        <FieldOffset(8)> Dim ulVal As ULong
        <FieldOffset(8)> Dim lVal As Long
        <FieldOffset(8)> Dim fltVal As Single
        <FieldOffset(8)> Dim dblVal As Double
        <FieldOffset(8)> Dim boolVal As Short
        <FieldOffset(8)> Dim pclsidVal As IntPtr
        <FieldOffset(8)> Dim pszVal As IntPtr
        <FieldOffset(8)> Dim pwszVal As IntPtr
        <FieldOffset(8)> Dim punkVal As IntPtr
        <FieldOffset(8)> Dim cArray As CArray
        <FieldOffset(8)> Dim filetime As ComTypes.FILETIME
    End Structure
#End Region

#Region "Events"
    Public Event ItemClick(Item As String, HitTest As NSTCEHITTEST, ClickType As NSTCECLICKTYPE)
    Public Event PropertyItemCommit(Item As String)
    Public Event ItemStateChanging(Item As String, Mask As NSTCITEMSTATE, State As NSTCITEMSTATE)
    Public Event ItemStateChanged(Item As String, Mask As NSTCITEMSTATE, State As NSTCITEMSTATE)
    Public Event SelectionChanged(Items As List(Of String))
    Public Event KeyboardInput(uMsg As Integer, wParam As Integer, lParam As Integer)
    Public Event BeforeExpand(Item As String)
    Public Event AfterExpand(Item As String)
    Public Event BeginLabelEdit(Item As String)
    Public Event EndLabelEdit(Item As String)
    Public Event GetToolTip(Item As String)
    Public Event BeforeItemDelete(Item As String)
    Public Event ItemAdded(Item As String, IsRoot As Boolean)
    Public Event ItemDeleted(Item As String, IsRoot As Boolean)
    Public Event BeforeContextMenu(Item As String)
    Public Event AfterContextMenu(Item As String)
    Public Event BeforeStateImageChange(Item As String)
    Public Event GetDefaultIconIndex(Item As String)
#End Region

#Region "Variable"
    Private ReadOnly m_Cookie As Integer
    Private m_NameSpaceTreeControl As INameSpaceTreeControl2
    Private m_hWndNameSpaceTreeControl As IntPtr
    Private m_hWndNameSpaceTreeControlSysTreeView32 As IntPtr
#End Region

#Region "Functions"
    Public Function Initialize(HwndParent As IntPtr,
                               Rect As Rectangle,
                               Flags As NSTCSTYLE) As Boolean
        Dim Ret As Boolean
        If m_NameSpaceTreeControl IsNot Nothing Then
            If m_NameSpaceTreeControl.Initialize(HwndParent,
                                                 Rect,
                                                 Flags) = S_OK Then
                Dim pIOleWindow As IntPtr
                If Marshal.QueryInterface(Marshal.GetIUnknownForObject(m_NameSpaceTreeControl),
                                          New Guid(IID_IOleWindow), pIOleWindow) = S_OK Then
                    If pIOleWindow <> IntPtr.Zero Then
                        Dim OleWindow As IOleWindow = DirectCast(Marshal.GetObjectForIUnknown(pIOleWindow), IOleWindow)
                        If OleWindow.GetWindow(m_hWndNameSpaceTreeControl) = S_OK Then
                            'm_hWndNameSpaceTreeControl für APIs wie zb. MoveWindow
                            m_hWndNameSpaceTreeControlSysTreeView32 = FindWindowExW(m_hWndNameSpaceTreeControl,
                                                                                    Nothing, "SysTreeView32", Nothing)
                            If m_hWndNameSpaceTreeControlSysTreeView32 <> IntPtr.Zero Then
                                ' m_hWndNameSpaceTreeControlSysTreeView32 für APIs zB. SendMessage oder Subclassing des TreeView
                            End If
                        End If
                        Marshal.ReleaseComObject(OleWindow)
                        Marshal.Release(pIOleWindow)
                    End If
                End If
                Ret = True
            End If
        End If
        Return Ret
    End Function

    Public Function AppendRoot(Root As String,
                               EnumFlags As SHCONTF,
                               RootStyle As NSTCROOTSTYLE,
                               Optional StateMask As NSTCITEMSTATE = NSTCITEMSTATE.NSTCIS_NONE,
                               Optional StateFlags As NSTCITEMSTATE = NSTCITEMSTATE.NSTCIS_NONE) As Boolean
        Dim Ret As Boolean
        If m_NameSpaceTreeControl IsNot Nothing Then
            Dim ShellItem As IShellItem = GetShellItem(Root)
            If ShellItem IsNot Nothing Then
                If m_NameSpaceTreeControl.AppendRoot(ShellItem, EnumFlags,
                                                     RootStyle, Nothing) = S_OK Then
                    If m_NameSpaceTreeControl.SetItemState(ShellItem, StateMask, StateFlags) = S_OK Then Ret = True
                End If
                Marshal.ReleaseComObject(ShellItem)
            End If
        End If
        Return Ret
    End Function

    Public Function InsertRoot(Index As Integer,
                               Root As String,
                               EnumFlags As SHCONTF,
                               RootStyle As NSTCROOTSTYLE,
                               Optional StateMask As NSTCITEMSTATE = NSTCITEMSTATE.NSTCIS_NONE,
                               Optional StateFlags As NSTCITEMSTATE = NSTCITEMSTATE.NSTCIS_NONE) As Boolean
        Dim Ret As Boolean
        If m_NameSpaceTreeControl IsNot Nothing Then
            Dim ShellItem As IShellItem = GetShellItem(Root)
            If ShellItem IsNot Nothing Then
                If m_NameSpaceTreeControl.InsertRoot(Index, ShellItem,
                                                     EnumFlags, RootStyle,
                                                     Nothing) = S_OK Then
                    If m_NameSpaceTreeControl.SetItemState(ShellItem, StateMask, StateFlags) = S_OK Then Ret = True
                End If
                Marshal.ReleaseComObject(ShellItem)
            End If
        End If
        Return Ret
    End Function

    Public Function RemoveRoot(Root As String) As Boolean
        Dim Ret As Boolean
        If m_NameSpaceTreeControl IsNot Nothing Then
            Dim ShellItem As IShellItem = GetShellItem(Root)
            If ShellItem IsNot Nothing Then
                If m_NameSpaceTreeControl.RemoveRoot(ShellItem) = S_OK Then Ret = True
                Marshal.ReleaseComObject(ShellItem)
            End If
        End If
        Return Ret
    End Function

    Public Function RemoveAllRoot() As Boolean
        Dim Ret As Boolean
        If m_NameSpaceTreeControl IsNot Nothing Then
            If m_NameSpaceTreeControl.RemoveAllRoot = S_OK Then Ret = True
        End If
        Return Ret
    End Function

    Public Function GetRootItems() As List(Of String)
        Dim Ret As New List(Of String)
        If m_NameSpaceTreeControl IsNot Nothing Then
            Dim ShellItemArray As IShellItemArray = Nothing
            If m_NameSpaceTreeControl.GetRootItems(ShellItemArray) = S_OK Then
                Dim Items As Integer
                If ShellItemArray.GetCount(Items) = S_OK Then
                    If Items > 0 Then
                        Dim ShellItem As IShellItem = Nothing
                        For Item As Integer = 0 To Items - 1
                            If ShellItemArray.GetItemAt(Item, ShellItem) = S_OK Then
                                Ret.Add(GetShellItemRoot(ShellItem))
                                Marshal.ReleaseComObject(ShellItem)
                                ShellItem = Nothing
                            End If
                        Next
                    End If
                End If
                Marshal.ReleaseComObject(ShellItemArray)
            End If
        End If
        Return Ret
    End Function

    Public Function SetItemState(Root As String,
                                 Mask As NSTCITEMSTATE,
                                 Flags As NSTCITEMSTATE) As Boolean
        Dim Ret As Boolean
        If m_NameSpaceTreeControl IsNot Nothing Then
            Dim ShellItem As IShellItem = GetShellItem(Root)
            If ShellItem IsNot Nothing Then
                If m_NameSpaceTreeControl.SetItemState(ShellItem, Mask, Flags) = S_OK Then Ret = True
                Marshal.ReleaseComObject(ShellItem)
            End If
        End If
        Return Ret
    End Function

    Public Function GetItemState(Root As String,
                                 Mask As NSTCITEMSTATE) As NSTCITEMSTATE
        Dim Ret As NSTCITEMSTATE
        If m_NameSpaceTreeControl IsNot Nothing Then
            Dim ShellItem As IShellItem = GetShellItem(Root)
            If ShellItem IsNot Nothing Then
                Dim Flags As NSTCITEMSTATE
                If m_NameSpaceTreeControl.GetItemState(ShellItem, Mask, Flags) = S_OK Then
                    Ret = Flags
                End If
                Marshal.ReleaseComObject(ShellItem)
            End If
        End If
        Return Ret
    End Function

    Public Function GetSelectedItems() As List(Of String)
        Dim Ret As New List(Of String)
        If m_NameSpaceTreeControl IsNot Nothing Then
            Dim ShellItemArray As IShellItemArray = Nothing
            If m_NameSpaceTreeControl.GetSelectedItems(ShellItemArray) = S_OK Then
                Dim Items As Integer
                If ShellItemArray.GetCount(Items) = S_OK Then
                    If Items > 0 Then
                        Dim ShellItem As IShellItem = Nothing
                        For Item As Integer = 0 To Items - 1
                            If ShellItemArray.GetItemAt(Item, ShellItem) = S_OK Then
                                Ret.Add(GetShellItemRoot(ShellItem))
                                Marshal.ReleaseComObject(ShellItem)
                                ShellItem = Nothing
                            End If
                        Next
                    End If
                End If
                Marshal.ReleaseComObject(ShellItemArray)
            End If
        End If
        Return Ret
    End Function

    Public Function GetItemCustomState(Root As String) As CheckBoxState
        Dim Ret As CheckBoxState
        If m_NameSpaceTreeControl IsNot Nothing Then
            Dim ShellItem As IShellItem = GetShellItem(Root)
            If ShellItem IsNot Nothing Then
                Dim StateNumber As CheckBoxState
                If m_NameSpaceTreeControl.GetItemCustomState(ShellItem, StateNumber) = S_OK Then
                    Ret = StateNumber
                End If
                Marshal.ReleaseComObject(ShellItem)
            End If
        End If
        Return Ret
    End Function

    Public Function SetItemCustomState(Root As String,
                                       StateNumber As CheckBoxState) As Boolean
        Dim Ret As Boolean
        If m_NameSpaceTreeControl IsNot Nothing Then
            Dim ShellItem As IShellItem = GetShellItem(Root)
            If ShellItem IsNot Nothing Then
                If m_NameSpaceTreeControl.SetItemCustomState(ShellItem, StateNumber) = S_OK Then Ret = True
                Marshal.ReleaseComObject(ShellItem)
            End If
        End If
        Return Ret
    End Function

    Public Function EnsureItemVisible(Root As String) As Boolean
        Dim Ret As Boolean
        If m_NameSpaceTreeControl IsNot Nothing Then
            Dim ShellItem As IShellItem = GetShellItem(Root)
            If ShellItem IsNot Nothing Then
                If m_NameSpaceTreeControl.EnsureItemVisible(ShellItem) = S_OK Then Ret = True
                Marshal.ReleaseComObject(ShellItem)
            End If
        End If
        Return Ret
    End Function

    Public Function SetTheme(Theme As String) As Boolean
        Dim Ret As Boolean
        If m_NameSpaceTreeControl IsNot Nothing Then
            If m_NameSpaceTreeControl.SetTheme(Theme) = S_OK Then Ret = True
        End If
        Return Ret
    End Function

    Public Function GetNextItem(Root As String,
                                Flags As NSTCGNI) As String
        Dim Ret As String = Nothing
        If m_NameSpaceTreeControl IsNot Nothing Then
            Dim ShellItem As IShellItem = GetShellItem(Root)
            If ShellItem IsNot Nothing Then
                Dim ShellItemNext As IShellItem = Nothing
                If m_NameSpaceTreeControl.GetNextItem(ShellItem, Flags,
                                                      ShellItemNext) = S_OK Then
                    Ret = GetShellItemRoot(ShellItemNext)
                    Marshal.ReleaseComObject(ShellItemNext)
                End If
                Marshal.ReleaseComObject(ShellItem)
            End If
        End If
        Return Ret
    End Function

    Public Function HitTest(PT As Point) As String
        Dim Ret As String = Nothing
        If m_NameSpaceTreeControl IsNot Nothing Then
            Dim ShellItem As IShellItem = Nothing
            If m_NameSpaceTreeControl.HitTest(PT, ShellItem) = S_OK Then
                Ret = GetShellItemRoot(ShellItem)
                Marshal.ReleaseComObject(ShellItem)
            End If
        End If
        Return Ret
    End Function

    Public Function GetItemRect(Root As String) As Rectangle
        Dim Ret As Rectangle
        If m_NameSpaceTreeControl IsNot Nothing Then
            Dim ShellItem As IShellItem = GetShellItem(Root)
            If ShellItem IsNot Nothing Then
                Dim Rect As New Rectangle
                If m_NameSpaceTreeControl.GetItemRect(ShellItem, Rect) = S_OK Then
                    Ret = Rect
                End If
                Marshal.ReleaseComObject(ShellItem)
            End If
        End If
        Return Ret
    End Function

    Public Function CollapseAll() As Boolean
        Dim Ret As Boolean
        If m_NameSpaceTreeControl IsNot Nothing Then
            If m_NameSpaceTreeControl.CollapseAll() = S_OK Then Ret = True
        End If
        Return Ret
    End Function

    Public Function SetControlStyle(Mask As NSTCSTYLE,
                                    Flags As NSTCSTYLE) As Boolean
        Dim Ret As Boolean
        If m_NameSpaceTreeControl IsNot Nothing Then
            If m_NameSpaceTreeControl.SetControlStyle(Mask, Flags) = S_OK Then Ret = True
        End If
        Return Ret
    End Function

    Public Function GetControlStyle(Mask As NSTCSTYLE) As NSTCSTYLE
        Dim Ret As NSTCSTYLE
        If m_NameSpaceTreeControl IsNot Nothing Then
            Dim Flags As NSTCSTYLE
            If m_NameSpaceTreeControl.GetControlStyle(Mask, Flags) = S_OK Then
                Ret = Flags
            End If
        End If
        Return Ret
    End Function

    Public Function SetControlStyle2(Mask As NSTCSTYLE2,
                                     Flags As NSTCSTYLE2) As Boolean
        Dim Ret As Boolean
        If m_NameSpaceTreeControl IsNot Nothing Then
            If m_NameSpaceTreeControl.SetControlStyle2(Mask, Flags) = S_OK Then Ret = True
        End If
        Return Ret
    End Function

    Public Function GetControlStyle2(Mask As NSTCSTYLE2) As NSTCSTYLE2
        Dim Ret As NSTCSTYLE2
        If m_NameSpaceTreeControl IsNot Nothing Then
            Dim Flags As NSTCSTYLE2
            If m_NameSpaceTreeControl.GetControlStyle2(Mask, Flags) = S_OK Then
                Ret = Flags
            End If
        End If
        Return Ret
    End Function

    ' zusätzliche Subs und Funktionen
    Private Function GetShellItem(Root As String) As IShellItem
        Dim Ret As Object = Nothing
        If Not String.IsNullOrEmpty(Root) Then
            If Root.StartsWith("::{") Then
                ' IShellItem von "::{Root}" erstellen
                If SHCreateItemFromParsingName(Root, Nothing,
                                               New Guid(IID_IShellItem), Ret) <> S_OK Then
                    ' IShellItem von "shell:::{Root}" erstellen
                    If SHCreateItemFromParsingName("shell:" & Root, Nothing,
                                               New Guid(IID_IShellItem), Ret) <> S_OK Then
                        ' erstellen von einem IShellItem ist fehlgeschlagen
                    End If
                End If
            ElseIf Root.StartsWith("{") Then
                ' IShellItem von FOLDERID_xxx erstellen
                Dim RootGuid As New Guid
                If Guid.TryParse(Root, RootGuid) Then
                    If SHCreateItemInKnownFolder(RootGuid, KNOWN_FOLDER_FLAG.KF_FLAG_DEFAULT,
                                              Nothing, New Guid(IID_IShellItem), Ret) <> S_OK Then
                        ' erstellen von einem IShellItem ist fehlgeschlagen
                    End If
                End If
            Else
                ' IShellItem von einem Pfad erstellen
                If SHCreateItemFromParsingName(Root, Nothing,
                                               New Guid(IID_IShellItem), Ret) <> S_OK Then
                    ' erstellen von einem IShellItem ist fehlgeschlagen
                End If
            End If
        End If
        Return DirectCast(Ret, IShellItem)
    End Function

    Private Function GetShellItemRoot(ShellItem As IShellItem) As String
        Dim Ret As String = Nothing
        If ShellItem IsNot Nothing Then
            Dim pName As IntPtr
            If ShellItem.GetDisplayName(SIGDN.SIGDN_DESKTOPABSOLUTEPARSING, pName) = S_OK Then
                Ret = Marshal.PtrToStringUni(pName)
                Marshal.FreeCoTaskMem(pName)
            End If
        End If
        Return Ret
    End Function

    Public Function Resize(Rect As Rectangle) As Boolean
        Dim Ret As Boolean
        If m_hWndNameSpaceTreeControl <> IntPtr.Zero Then
            Ret = MoveWindow(m_hWndNameSpaceTreeControl,
                             Rect.Left, Rect.Top,
                             Rect.Width - Rect.Left,
                             Rect.Height - Rect.Top, True)
        End If
        Return Ret
    End Function

    Public Sub SetIndent(Indent As Integer)
        If m_hWndNameSpaceTreeControlSysTreeView32 <> IntPtr.Zero Then
            SendMessage(m_hWndNameSpaceTreeControlSysTreeView32, TVM_SETINDENT, Indent, 0)
        End If
    End Sub

    Public Function GetIndent() As Integer
        Dim Ret As Integer
        If m_hWndNameSpaceTreeControlSysTreeView32 <> IntPtr.Zero Then
            Ret = SendMessage(m_hWndNameSpaceTreeControlSysTreeView32, TVM_GETINDENT, 0, 0)
        End If
        Return Ret
    End Function

    Public Function SetItemHeight(ItemHeight As Integer) As Integer
        Dim Ret As Integer
        If m_hWndNameSpaceTreeControlSysTreeView32 <> IntPtr.Zero Then
            Ret = SendMessage(m_hWndNameSpaceTreeControlSysTreeView32, TVM_SETITEMHEIGHT, ItemHeight, 0)
        End If
        Return Ret
    End Function

    Public Function GetItemHeight() As Integer
        Dim Ret As Integer
        If m_hWndNameSpaceTreeControlSysTreeView32 <> IntPtr.Zero Then
            Ret = SendMessage(m_hWndNameSpaceTreeControlSysTreeView32, TVM_GETITEMHEIGHT, 0, 0)
        End If
        Return Ret
    End Function

    Public Function SetBackColor(BackColor As Color) As Color
        Dim Ret As Color
        If m_hWndNameSpaceTreeControlSysTreeView32 <> IntPtr.Zero Then
            ' ARGB to BGR
            Dim OldColor As Color = Color.FromArgb(SendMessage(m_hWndNameSpaceTreeControlSysTreeView32, TVM_SETBKCOLOR, 0, Color.FromArgb(0, BackColor.B, BackColor.G, BackColor.R).ToArgb))
            ' BGR to ARGB
            Ret = Color.FromArgb(255, OldColor.B, OldColor.G, OldColor.R)
        End If
        Return Ret
    End Function

    Public Function GetBackColor() As Color
        Dim Ret As Color
        If m_hWndNameSpaceTreeControlSysTreeView32 <> IntPtr.Zero Then
            Dim CurrentColor As Color = Color.FromArgb(SendMessage(m_hWndNameSpaceTreeControlSysTreeView32, TVM_GETBKCOLOR, 0, 0))
            ' BGR to ARGB
            Ret = Color.FromArgb(255, CurrentColor.B, CurrentColor.G, CurrentColor.R)
        End If
        Return Ret
    End Function

    Public Function SetLineColor(BackColor As Color) As Color
        Dim Ret As Color
        If m_hWndNameSpaceTreeControlSysTreeView32 <> IntPtr.Zero Then
            ' ARGB to BGR
            Dim OldColor As Color = Color.FromArgb(SendMessage(m_hWndNameSpaceTreeControlSysTreeView32, TVM_SETLINECOLOR, 0, Color.FromArgb(0, BackColor.B, BackColor.G, BackColor.R).ToArgb))
            ' BGR to ARGB
            Ret = Color.FromArgb(255, OldColor.B, OldColor.G, OldColor.R)
        End If
        Return Ret
    End Function

    Public Function GetLineColor() As Color
        Dim Ret As Color
        If m_hWndNameSpaceTreeControlSysTreeView32 <> IntPtr.Zero Then
            Dim CurrentColor As Color = Color.FromArgb(SendMessage(m_hWndNameSpaceTreeControlSysTreeView32, TVM_GETLINECOLOR, 0, 0))
            ' BGR to ARGB
            Ret = Color.FromArgb(255, CurrentColor.B, CurrentColor.G, CurrentColor.R)
        End If
        Return Ret
    End Function

    Public Function SetTextColor(BackColor As Color) As Color
        Dim Ret As Color
        If m_hWndNameSpaceTreeControlSysTreeView32 <> IntPtr.Zero Then
            ' ARGB to BGR
            Dim OldColor As Color = Color.FromArgb(SendMessage(m_hWndNameSpaceTreeControlSysTreeView32, TVM_SETTEXTCOLOR, 0, Color.FromArgb(0, BackColor.B, BackColor.G, BackColor.R).ToArgb))
            ' BGR to ARGB
            Ret = Color.FromArgb(255, OldColor.B, OldColor.G, OldColor.R)
        End If
        Return Ret
    End Function

    Public Function GetTextColor() As Color
        Dim Ret As Color
        If m_hWndNameSpaceTreeControlSysTreeView32 <> IntPtr.Zero Then
            Dim CurrentColor As Color = Color.FromArgb(SendMessage(m_hWndNameSpaceTreeControlSysTreeView32, TVM_GETTEXTCOLOR, 0, 0))
            ' BGR to ARGB
            Ret = Color.FromArgb(255, CurrentColor.B, CurrentColor.G, CurrentColor.R)
        End If
        Return Ret
    End Function

#End Region

#Region "Interface IOleWindow"
    <ComImport>
    <InterfaceType(ComInterfaceType.InterfaceIsIUnknown)>
    <Guid(IID_IOleWindow)>
    Private Interface IOleWindow
        <PreserveSig> Function GetWindow(<Out> ByRef phwnd As IntPtr) As Integer
        <PreserveSig> Function ContextSensitiveHelp(<[In], MarshalAs(UnmanagedType.Bool)> fEnterMode As Boolean) As Integer
    End Interface
#End Region

#Region "Interface IShellItem"
    <ComImport>
    <InterfaceType(ComInterfaceType.InterfaceIsIUnknown)>
    <Guid(IID_IShellItem)>
    Private Interface IShellItem
        <PreserveSig> Function BindToHandler(<[In]> pbc As IntPtr,
                                             <[In]> ByRef bhid As Guid,
                                             <[In]> ByRef riid As Guid,
                                             <Out, MarshalAs(UnmanagedType.Interface)> ByRef ppvOut As Object) As Integer
        <PreserveSig> Function GetParent(<Out, MarshalAs(UnmanagedType.Interface)> ByRef ppsi As IShellItem) As Integer
        <PreserveSig> Function GetDisplayName(<[In]> sigdnName As SIGDN,
                                              <Out> ByRef ppszName As IntPtr) As Integer
        <PreserveSig> Function GetAttributes(<[In]> sfgaoMask As SFGAOF,
                                             <Out> ByRef psfgaoAttribs As SFGAOF) As Integer
        <PreserveSig> Function Compare(<[In], MarshalAs(UnmanagedType.Interface)> psi As IShellItem,
                                       <[In]> hint As SICHINTF,
                                       <Out> ByRef piOrder As Integer) As Integer
    End Interface
#End Region

#Region "Interface IShellItem2"
    <ComImport>
    <InterfaceType(ComInterfaceType.InterfaceIsIUnknown)>
    <Guid(IID_IShellItem2)>
    Private Interface IShellItem2
        Inherits IShellItem
        <PreserveSig> Shadows Function BindToHandler(<[In]> pbc As IntPtr,
                                                     <[In]> ByRef bhid As Guid,
                                                     <[In]> ByRef riid As Guid,
                                                     <Out, MarshalAs(UnmanagedType.Interface)> ByRef ppvOut As Object) As Integer
        <PreserveSig> Shadows Function GetParent(<Out, MarshalAs(UnmanagedType.Interface)> ByRef ppsi As IShellItem) As Integer
        <PreserveSig> Shadows Function GetDisplayName(<[In]> sigdnName As SIGDN,
                                                      <Out> ByRef ppszName As IntPtr) As Integer
        <PreserveSig> Shadows Function GetAttributes(<[In]> sfgaoMask As SFGAOF,
                                                     <Out> ByRef psfgaoAttribs As SFGAOF) As Integer
        <PreserveSig> Shadows Function Compare(<[In], MarshalAs(UnmanagedType.Interface)> psi As IShellItem,
                                               <[In]> hint As SICHINTF,
                                               <Out> ByRef piOrder As Integer) As Integer
        <PreserveSig> Function GetPropertyStore(<[In]> flags As GETPROPERTYSTOREFLAGS,
                                                <[In]> ByRef riid As Guid,
                                                <Out, MarshalAs(UnmanagedType.Interface)> ByRef ppv As Object) As Integer
        <PreserveSig> Function GetPropertyStoreWithCreateObject(<[In]> flags As GETPROPERTYSTOREFLAGS,
                                                                <[In], MarshalAs(UnmanagedType.Interface)> punkCreateObject As Object,
                                                                <[In]> ByRef riid As Guid,
                                                                <Out, MarshalAs(UnmanagedType.Interface)> ByRef ppv As Object) As Integer
        <PreserveSig> Function GetPropertyStoreForKeys(<[In]> ByRef rgKeys() As PROPERTYKEY,
                                                       <[In]> cKeys As UInteger,
                                                       <[In]> flags As GETPROPERTYSTOREFLAGS,
                                                       <[In]> ByRef riid As Guid,
                                                       <Out, MarshalAs(UnmanagedType.Interface)> ByRef ppv As Object) As Integer
        <PreserveSig> Function GetPropertyDescriptionList(<[In]> ByRef keyType As PROPERTYKEY,
                                                          <[In]> ByRef riid As Guid,
                                                          <Out, MarshalAs(UnmanagedType.Interface)> ByRef ppv As Object) As Integer
        <PreserveSig> Function Update(<[In]> pbc As IntPtr) As Integer
        <PreserveSig> Function GetProperty(<[In]> ByRef key As PROPERTYKEY,
                                           <Out> ByRef ppropvar As PROPVARIANT) As Integer
        <PreserveSig> Function GetCLSID(<[In]> ByRef key As PROPERTYKEY,
                                        <Out> ByRef pclsid As Guid) As Integer
        <PreserveSig> Function GetCLSID(<[In]> ByRef key As PROPERTYKEY,
                                        <Out> ByRef pft As ComTypes.FILETIME) As Integer
        <PreserveSig> Function GetInt32(<[In]> ByRef key As PROPERTYKEY,
                                        <Out> ByRef pi As Integer) As Integer
        <PreserveSig> Function GetString(<[In]> ByRef key As PROPERTYKEY,
                                         <Out> ByRef ppsz As IntPtr) As Integer
        <PreserveSig> Function GetUInt32(<[In]> ByRef key As PROPERTYKEY,
                                         <Out> ByRef pi As UInteger) As Integer
        <PreserveSig> Function GetUInt64(<[In]> ByRef key As PROPERTYKEY,
                                         <Out> ByRef pi As ULong) As Integer
        <PreserveSig> Function GetBool(<[In]> ByRef key As PROPERTYKEY,
                                       <Out, MarshalAs(UnmanagedType.Bool)> ByRef pf As Boolean) As Integer
    End Interface
#End Region

#Region "Interface IShellItemArray"
    <ComImport>
    <InterfaceType(ComInterfaceType.InterfaceIsIUnknown)>
    <Guid(IID_IShellItemArray)>
    Private Interface IShellItemArray
        <PreserveSig> Function BindToHandler(<[In]> pbc As IntPtr,
                                             <[In]> ByRef bhid As Guid,
                                             <[In]> ByRef riid As Guid,
                                             <Out, MarshalAs(UnmanagedType.Interface)> ByRef ppvOut As Object) As Integer
        <PreserveSig> Function GetPropertyStore(<[In]> flags As GETPROPERTYSTOREFLAGS,
                                                <[In]> ByRef riid As Guid,
                                                <Out, MarshalAs(UnmanagedType.Interface)> ByRef ppv As Object) As Integer
        <PreserveSig> Function GetPropertyDescriptionList(<[In]> ByRef keyType As PROPERTYKEY,
                                                          <[In]> ByRef riid As Guid,
                                                          <Out, MarshalAs(UnmanagedType.Interface)> ByRef ppv As Object) As Integer
        <PreserveSig> Function GetAttributes(<[In]> AttribFlags As SIATTRIBFLAGS,
                                             <[In]> sfgaoMask As SFGAOF,
                                             <Out> ByRef psfgaoAttribs As SFGAOF) As Integer
        <PreserveSig> Function GetCount(<Out> ByRef pdwNumItems As Integer) As Integer
        <PreserveSig> Function GetItemAt(<[In]> dwIndex As Integer,
                                         <Out, MarshalAs(UnmanagedType.Interface)> ByRef ppsi As IShellItem) As Integer
        <PreserveSig> Function EnumItems(<Out, MarshalAs(UnmanagedType.Interface)> ByRef ppenumShellItems As IEnumShellItems) As Integer
    End Interface
#End Region

#Region "Interface IEnumShellItems"
    <ComImport>
    <InterfaceType(ComInterfaceType.InterfaceIsIUnknown)>
    <Guid(IID_IEnumShellItems)>
    Private Interface IEnumShellItems
        <PreserveSig> Function [Next](<[In]> celt As Integer,
                                      <Out, MarshalAs(UnmanagedType.Interface)> ByRef rgelt As IShellItem,
                                      <Out> ByRef pceltFetched As Integer) As Integer
        <PreserveSig> Function Skip(<[In]> celt As Integer) As Integer
        <PreserveSig> Function Reset() As Integer
        <PreserveSig> Function Clone(<Out, MarshalAs(UnmanagedType.Interface)> ByRef ppenum As IEnumShellItems) As Integer
    End Interface
#End Region

#Region "Interface INameSpaceTreeControl"
    <ComImport>
    <InterfaceType(ComInterfaceType.InterfaceIsIUnknown)>
    <Guid(IID_INameSpaceTreeControl)>
    Private Interface INameSpaceTreeControl
        <PreserveSig> Function Initialize(<[In]> hwndParent As IntPtr,
                                          <[In]> ByRef prc As Rectangle,
                                          <[In]> nsctsFlags As NSTCSTYLE) As Integer
        <PreserveSig> Function TreeAdvise(<[In]> punk As IntPtr,
                                          <Out> ByRef pdwCookie As Integer) As Integer
        <PreserveSig> Function TreeUnadvise(<[In]> dwCookie As Integer) As Integer
        <PreserveSig> Function AppendRoot(<[In], MarshalAs(UnmanagedType.Interface)> psiRoot As IShellItem,
                                          <[In]> grfEnumFlags As SHCONTF,
                                          <[In]> grfRootStyle As NSTCROOTSTYLE,
                                          <[In]> pif As IntPtr) As Integer 'pif As IShellItemFilter
        <PreserveSig> Function InsertRoot(<[In]> iIndex As Integer,
                                          <[In], MarshalAs(UnmanagedType.Interface)> psiRoot As IShellItem,
                                          <[In]> grfEnumFlags As SHCONTF,
                                          <[In]> grfRootStyle As NSTCROOTSTYLE,
                                          <[In]> pif As IntPtr) As Integer 'pif As IShellItemFilter
        <PreserveSig> Function RemoveRoot(<[In], MarshalAs(UnmanagedType.Interface)> psiRoot As IShellItem) As Integer
        <PreserveSig> Function RemoveAllRoot() As Integer
        <PreserveSig> Function GetRootItems(<Out, MarshalAs(UnmanagedType.Interface)> ByRef ppsiaRootItems As IShellItemArray) As Integer
        <PreserveSig> Function SetItemState(<[In], MarshalAs(UnmanagedType.Interface)> psiRoot As IShellItem,
                                            <[In]> nstcisMask As NSTCITEMSTATE,
                                            <[In]> nstcisFlags As NSTCITEMSTATE) As Integer
        <PreserveSig> Function GetItemState(<[In], MarshalAs(UnmanagedType.Interface)> psiRoot As IShellItem,
                                            <[In]> nstcisMask As NSTCITEMSTATE,
                                            <Out> ByRef pnstcisFlags As NSTCITEMSTATE) As Integer
        <PreserveSig> Function GetSelectedItems(<Out, MarshalAs(UnmanagedType.Interface)> ByRef ppsiaRootItems As IShellItemArray) As Integer
        <PreserveSig> Function GetItemCustomState(<[In], MarshalAs(UnmanagedType.Interface)> psi As IShellItem,
                                                  <Out> ByRef piStateNumber As CheckBoxState) As Integer
        <PreserveSig> Function SetItemCustomState(<[In], MarshalAs(UnmanagedType.Interface)> psi As IShellItem,
                                                  <[In]> iStateNumber As CheckBoxState) As Integer
        <PreserveSig> Function EnsureItemVisible(<[In], MarshalAs(UnmanagedType.Interface)> psi As IShellItem) As Integer
        <PreserveSig> Function SetTheme(<[In], MarshalAs(UnmanagedType.LPWStr)> pszTheme As String) As Integer
        <PreserveSig> Function GetNextItem(<[In], MarshalAs(UnmanagedType.Interface)> psi As IShellItem,
                                           <[In]> nstcgi As NSTCGNI,
                                           <Out, MarshalAs(UnmanagedType.Interface)> ByRef ppsiNext As IShellItem) As Integer
        <PreserveSig> Function HitTest(<[In]> ByRef ppt As Point,
                                       <Out, MarshalAs(UnmanagedType.Interface)> ByRef ppsiOut As IShellItem) As Integer
        <PreserveSig> Function GetItemRect(<[In], MarshalAs(UnmanagedType.Interface)> psi As IShellItem,
                                           <Out> ByRef prect As Rectangle) As Integer
        <PreserveSig> Function CollapseAll() As Integer
    End Interface
#End Region

#Region "Interface INameSpaceTreeControl2"
    <ComImport>
    <InterfaceType(ComInterfaceType.InterfaceIsIUnknown)>
    <Guid(IID_INameSpaceTreeControl2)>
    Private Interface INameSpaceTreeControl2
        Inherits INameSpaceTreeControl
        <PreserveSig> Shadows Function Initialize(<[In]> hwndParent As IntPtr,
                                                  <[In]> ByRef prc As Rectangle,
                                                  <[In]> nsctsFlags As NSTCSTYLE) As Integer
        <PreserveSig> Shadows Function TreeAdvise(<[In]> punk As IntPtr,
                                                  <Out> ByRef pdwCookie As Integer) As Integer
        <PreserveSig> Shadows Function TreeUnadvise(<[In]> dwCookie As Integer) As Integer
        <PreserveSig> Shadows Function AppendRoot(<[In], MarshalAs(UnmanagedType.Interface)> psiRoot As IShellItem,
                                                  <[In]> grfEnumFlags As SHCONTF,
                                                  <[In]> grfRootStyle As NSTCROOTSTYLE,
                                                  <[In]> pif As IntPtr) As Integer 'pif As IShellItemFilter
        <PreserveSig> Shadows Function InsertRoot(<[In]> iIndex As Integer,
                                                  <[In], MarshalAs(UnmanagedType.Interface)> psiRoot As IShellItem,
                                                  <[In]> grfEnumFlags As SHCONTF,
                                                  <[In]> grfRootStyle As NSTCROOTSTYLE,
                                                  <[In]> pif As IntPtr) As Integer 'pif As IShellItemFilter
        <PreserveSig> Shadows Function RemoveRoot(<[In], MarshalAs(UnmanagedType.Interface)> psiRoot As IShellItem) As Integer
        <PreserveSig> Shadows Function RemoveAllRoot() As Integer
        <PreserveSig> Shadows Function GetRootItems(<Out, MarshalAs(UnmanagedType.Interface)> ByRef ppsiaRootItems As IShellItemArray) As Integer
        <PreserveSig> Shadows Function SetItemState(<[In], MarshalAs(UnmanagedType.Interface)> psiRoot As IShellItem,
                                                    <[In]> nstcisMask As NSTCITEMSTATE,
                                                    <[In]> nstcisFlags As NSTCITEMSTATE) As Integer
        <PreserveSig> Shadows Function GetItemState(<[In], MarshalAs(UnmanagedType.Interface)> psiRoot As IShellItem,
                                                    <[In]> nstcisMask As NSTCITEMSTATE,
                                                    <Out> ByRef pnstcisFlags As NSTCITEMSTATE) As Integer
        <PreserveSig> Shadows Function GetSelectedItems(<Out, MarshalAs(UnmanagedType.Interface)> ByRef ppsiaRootItems As IShellItemArray) As Integer
        <PreserveSig> Shadows Function GetItemCustomState(<[In], MarshalAs(UnmanagedType.Interface)> psi As IShellItem,
                                                          <Out> ByRef piStateNumber As CheckBoxState) As Integer
        <PreserveSig> Shadows Function SetItemCustomState(<[In], MarshalAs(UnmanagedType.Interface)> psi As IShellItem,
                                                          <[In]> iStateNumber As CheckBoxState) As Integer
        <PreserveSig> Shadows Function EnsureItemVisible(<[In], MarshalAs(UnmanagedType.Interface)> psi As IShellItem) As Integer
        <PreserveSig> Shadows Function SetTheme(<[In], MarshalAs(UnmanagedType.LPWStr)> pszTheme As String) As Integer
        <PreserveSig> Shadows Function GetNextItem(<[In], MarshalAs(UnmanagedType.Interface)> psi As IShellItem,
                                                   <[In]> nstcgi As NSTCGNI,
                                                   <Out, MarshalAs(UnmanagedType.Interface)> ByRef ppsiNext As IShellItem) As Integer
        <PreserveSig> Shadows Function HitTest(<[In]> ByRef ppt As Point,
                                               <Out, MarshalAs(UnmanagedType.Interface)> ByRef ppsiOut As IShellItem) As Integer
        <PreserveSig> Shadows Function GetItemRect(<[In], MarshalAs(UnmanagedType.Interface)> psi As IShellItem,
                                                   <Out> ByRef prect As Rectangle) As Integer
        <PreserveSig> Shadows Function CollapseAll() As Integer
        <PreserveSig> Function SetControlStyle(<[In]> nstcsMask As NSTCSTYLE,
                                               <[In]> nstcsFlags As NSTCSTYLE) As Integer
        <PreserveSig> Function GetControlStyle(<[In]> nstcsMask As NSTCSTYLE,
                                               <Out> ByRef pnstcsFlags As NSTCSTYLE) As Integer
        <PreserveSig> Function SetControlStyle2(<[In]> nstcsMask As NSTCSTYLE2,
                                                <[In]> nstcsFlags As NSTCSTYLE2) As Integer
        <PreserveSig> Function GetControlStyle2(<[In]> nstcsMask As NSTCSTYLE2,
                                                <Out> ByRef pnstcsFlags As NSTCSTYLE2) As Integer
    End Interface
#End Region

#Region "Interface INameSpaceTreeControlEvents"
    <ComImport>
    <InterfaceType(ComInterfaceType.InterfaceIsIUnknown)>
    <Guid(IID_INameSpaceTreeControlEvents)>
    Private Interface INameSpaceTreeControlEvents
        <PreserveSig> Function OnItemClick(<[In], MarshalAs(UnmanagedType.Interface)> psi As IShellItem,
                                           <[In]> nstceHitTest As NSTCEHITTEST,
                                           <[In]> nstceClickType As NSTCECLICKTYPE) As Integer
        <PreserveSig> Function OnPropertyItemCommit(<[In], MarshalAs(UnmanagedType.Interface)> psi As IShellItem) As Integer
        <PreserveSig> Function OnItemStateChanging(<[In], MarshalAs(UnmanagedType.Interface)> psi As IShellItem,
                                                   <[In]> nstcisMask As NSTCITEMSTATE,
                                                   <[In]> nstcisState As NSTCITEMSTATE) As Integer
        <PreserveSig> Function OnItemStateChanged(<[In], MarshalAs(UnmanagedType.Interface)> psi As IShellItem,
                                                  <[In]> nstcisMask As NSTCITEMSTATE,
                                                  <[In]> nstcisState As NSTCITEMSTATE) As Integer
        <PreserveSig> Function OnSelectionChanged(<[In], MarshalAs(UnmanagedType.Interface)> psiaSelection As IShellItemArray) As Integer
        <PreserveSig> Function OnKeyboardInput(<[In]> uMsg As Integer,
                                               <[In]> wParam As Integer,
                                               <[In]> lParam As Integer) As Integer
        <PreserveSig> Function OnBeforeExpand(<[In], MarshalAs(UnmanagedType.Interface)> psi As IShellItem) As Integer
        <PreserveSig> Function OnAfterExpand(<[In], MarshalAs(UnmanagedType.Interface)> psi As IShellItem) As Integer
        <PreserveSig> Function OnBeginLabelEdit(<[In], MarshalAs(UnmanagedType.Interface)> psi As IShellItem) As Integer
        <PreserveSig> Function OnEndLabelEdit(<[In], MarshalAs(UnmanagedType.Interface)> psi As IShellItem) As Integer
        <PreserveSig> Function OnGetToolTip(<[In], MarshalAs(UnmanagedType.Interface)> psi As IShellItem,
                                            <Out> ByRef pszTip As IntPtr,
                                            <[In]> cchTip As Integer) As Integer
        <PreserveSig> Function OnBeforeItemDelete(<[In], MarshalAs(UnmanagedType.Interface)> psi As IShellItem) As Integer
        <PreserveSig> Function OnItemAdded(<[In], MarshalAs(UnmanagedType.Interface)> psi As IShellItem,
                                           <[In], MarshalAs(UnmanagedType.Bool)> fIsRoot As Boolean) As Integer
        <PreserveSig> Function OnItemDeleted(<[In], MarshalAs(UnmanagedType.Interface)> psi As IShellItem,
                                             <[In], MarshalAs(UnmanagedType.Bool)> fIsRoot As Boolean) As Integer
        <PreserveSig> Function OnBeforeContextMenu(<[In], MarshalAs(UnmanagedType.Interface)> psi As IShellItem,
                                                   <[In]> ByRef riid As Guid,
                                                   <Out, MarshalAs(UnmanagedType.Interface)> ByRef ppv As Object) As Integer
        <PreserveSig> Function OnAfterContextMenu(<[In], MarshalAs(UnmanagedType.Interface)> psi As IShellItem,
                                                  <[In]> pcmIn As IntPtr, 'pcmIn as IContextMenu
                                                  <[In]> ByRef riid As Guid,
                                                  <Out, MarshalAs(UnmanagedType.Interface)> ByRef ppv As Object) As Integer
        <PreserveSig> Function OnBeforeStateImageChange(<[In], MarshalAs(UnmanagedType.Interface)> psi As IShellItem) As Integer
        <PreserveSig> Function OnGetDefaultIconIndex(<[In], MarshalAs(UnmanagedType.Interface)> psi As IShellItem,
                                                     <Out> ByRef piDefaultIcon As Integer,
                                                     <Out> ByRef piOpenIcon As Integer) As Integer
    End Interface
#End Region

#Region "Implements INameSpaceTreeControlEvents"
    Private Function OnItemClick(<[In]> <MarshalAs(UnmanagedType.Interface)> psi As IShellItem,
                                 <[In]> nstceHitTest As NSTCEHITTEST,
                                 <[In]> nstceClickType As NSTCECLICKTYPE) As Integer Implements INameSpaceTreeControlEvents.OnItemClick
        RaiseEvent ItemClick(GetShellItemRoot(psi), nstceHitTest, nstceClickType)
        Return S_FALSE
    End Function
    Private Function OnPropertyItemCommit(<[In]> <MarshalAs(UnmanagedType.Interface)> psi As IShellItem) As Integer Implements INameSpaceTreeControlEvents.OnPropertyItemCommit
        RaiseEvent PropertyItemCommit(GetShellItemRoot(psi))
        Return S_FALSE
    End Function

    Private Function OnItemStateChanging(<[In]> <MarshalAs(UnmanagedType.Interface)> psi As IShellItem,
                                         <[In]> nstcisMask As NSTCITEMSTATE,
                                         <[In]> nstcisState As NSTCITEMSTATE) As Integer Implements INameSpaceTreeControlEvents.OnItemStateChanging
        RaiseEvent ItemStateChanging(GetShellItemRoot(psi), nstcisMask, nstcisState)
        Return S_FALSE
    End Function

    Private Function OnItemStateChanged(<[In]> <MarshalAs(UnmanagedType.Interface)> psi As IShellItem,
                                        <[In]> nstcisMask As NSTCITEMSTATE,
                                        <[In]> nstcisState As NSTCITEMSTATE) As Integer Implements INameSpaceTreeControlEvents.OnItemStateChanged
        RaiseEvent ItemStateChanged(GetShellItemRoot(psi), nstcisMask, nstcisState)
        Return S_FALSE
    End Function

    Private Function OnSelectionChanged(<[In]> <MarshalAs(UnmanagedType.Interface)> psiaSelection As IShellItemArray) As Integer Implements INameSpaceTreeControlEvents.OnSelectionChanged
        Dim Count As Integer
        Dim Items As New List(Of String)
        If psiaSelection.GetCount(Count) = S_OK Then
            If Count > 0 Then
                Dim ShellItem As IShellItem = Nothing
                For Item As Integer = 0 To Count - 1
                    If psiaSelection.GetItemAt(Item, ShellItem) = S_OK Then
                        Items.Add(GetShellItemRoot(ShellItem))
                        Marshal.ReleaseComObject(ShellItem)
                        ShellItem = Nothing
                    End If
                Next
                RaiseEvent SelectionChanged(Items)
            End If
        End If
        Return S_FALSE
    End Function

    Private Function OnKeyboardInput(<[In]> uMsg As Integer,
                                     <[In]> wParam As Integer,
                                     <[In]> lParam As Integer) As Integer Implements INameSpaceTreeControlEvents.OnKeyboardInput
        RaiseEvent KeyboardInput(uMsg, wParam, lParam)
        Return S_FALSE
    End Function

    Private Function OnBeforeExpand(<[In]> <MarshalAs(UnmanagedType.Interface)> psi As IShellItem) As Integer Implements INameSpaceTreeControlEvents.OnBeforeExpand
        RaiseEvent BeforeExpand(GetShellItemRoot(psi))
        Return S_FALSE
    End Function

    Private Function OnAfterExpand(<[In]> <MarshalAs(UnmanagedType.Interface)> psi As IShellItem) As Integer Implements INameSpaceTreeControlEvents.OnAfterExpand
        RaiseEvent AfterExpand(GetShellItemRoot(psi))
        Return S_FALSE
    End Function

    Private Function OnBeginLabelEdit(<[In]> <MarshalAs(UnmanagedType.Interface)> psi As IShellItem) As Integer Implements INameSpaceTreeControlEvents.OnBeginLabelEdit
        RaiseEvent BeginLabelEdit(GetShellItemRoot(psi))
        Return S_FALSE
    End Function

    Private Function OnEndLabelEdit(<[In]> <MarshalAs(UnmanagedType.Interface)> psi As IShellItem) As Integer Implements INameSpaceTreeControlEvents.OnEndLabelEdit
        RaiseEvent EndLabelEdit(GetShellItemRoot(psi))
        Return S_FALSE
    End Function

    Private Function OnGetToolTip(<[In]> <MarshalAs(UnmanagedType.Interface)> psi As IShellItem,
                                  <Out> ByRef pszTip As IntPtr,
                                  <[In]> cchTip As Integer) As Integer Implements INameSpaceTreeControlEvents.OnGetToolTip
        RaiseEvent GetToolTip(GetShellItemRoot(psi))
        Return E_NOTIMPL
    End Function

    Private Function OnBeforeItemDelete(<[In]> <MarshalAs(UnmanagedType.Interface)> psi As IShellItem) As Integer Implements INameSpaceTreeControlEvents.OnBeforeItemDelete
        RaiseEvent BeforeItemDelete(GetShellItemRoot(psi))
        Return S_FALSE
    End Function

    Private Function OnItemAdded(<[In]> <MarshalAs(UnmanagedType.Interface)> psi As IShellItem,
                                 <[In]> <MarshalAs(UnmanagedType.Bool)> fIsRoot As Boolean) As Integer Implements INameSpaceTreeControlEvents.OnItemAdded
        RaiseEvent ItemAdded(GetShellItemRoot(psi), fIsRoot)
        Return S_FALSE
    End Function

    Private Function OnItemDeleted(<[In]> <MarshalAs(UnmanagedType.Interface)> psi As IShellItem,
                                   <[In]> <MarshalAs(UnmanagedType.Bool)> fIsRoot As Boolean) As Integer Implements INameSpaceTreeControlEvents.OnItemDeleted
        RaiseEvent ItemDeleted(GetShellItemRoot(psi), fIsRoot)
        Return S_FALSE
    End Function

    Private Function OnBeforeContextMenu(<[In]> <MarshalAs(UnmanagedType.Interface)> psi As IShellItem,
                                         <[In]> ByRef riid As Guid,
                                         <MarshalAs(UnmanagedType.Interface)> <Out> ByRef ppv As Object) As Integer Implements INameSpaceTreeControlEvents.OnBeforeContextMenu

        RaiseEvent BeforeContextMenu(GetShellItemRoot(psi))
        Return E_NOTIMPL
    End Function

    Private Function OnAfterContextMenu(<[In]> <MarshalAs(UnmanagedType.Interface)> psi As IShellItem,
                                        <[In]> pcmIn As IntPtr,
                                        <[In]> ByRef riid As Guid,
                                        <MarshalAs(UnmanagedType.Interface)> <Out> ByRef ppv As Object) As Integer Implements INameSpaceTreeControlEvents.OnAfterContextMenu
        RaiseEvent AfterContextMenu(GetShellItemRoot(psi))
        Return E_NOTIMPL
    End Function

    Private Function OnBeforeStateImageChange(<[In]> <MarshalAs(UnmanagedType.Interface)> psi As IShellItem) As Integer Implements INameSpaceTreeControlEvents.OnBeforeStateImageChange
        RaiseEvent BeforeStateImageChange(GetShellItemRoot(psi))
        Return S_FALSE
    End Function

    Private Function OnGetDefaultIconIndex(<[In]> <MarshalAs(UnmanagedType.Interface)> psi As IShellItem,
                                           <Out> ByRef piDefaultIcon As Integer,
                                           <Out> ByRef piOpenIcon As Integer) As Integer Implements INameSpaceTreeControlEvents.OnGetDefaultIconIndex
        RaiseEvent GetDefaultIconIndex(GetShellItemRoot(psi))
        Return E_NOTIMPL
    End Function
#End Region

End Class

